﻿using System;
using System.Text;
using HeuristicLab.Problems.QuadraticAssignment;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Tests {
  [TestClass]
  public class QAPLIBInstancesTest {
    [TestMethod]
    public void LoadAllEmbeddedInstances() {
      QuadraticAssignmentProblem qap = new QuadraticAssignmentProblem();
      StringBuilder failedInstances = new StringBuilder();
      foreach (string instance in qap.EmbeddedInstances) {
        try {
          qap.LoadEmbeddedInstance(instance);
        } catch (Exception ex) {
          failedInstances.AppendLine(instance + ": " + ex.Message);
        }
      }
      Assert.IsTrue(failedInstances.Length == 0, "Following instances failed to load: " + Environment.NewLine + failedInstances.ToString());
    }
  }
}
